<script setup lang="ts">
    import { myselfGmaoActeurInjectionKey } from '@/interventionServiceOffer/constants'
    import { ActiviteAction } from '@/interventionServiceOffer/entities/activite/ActiviteAction'
    import { isDefined, requiredInject } from '@/shared/helpers/types'
    import { ref, watch } from 'vue'

    const myself = requiredInject(myselfGmaoActeurInjectionKey)

    interface Props {
        estModifiable?: boolean
        modeSuppression?: boolean
    }
    const props = withDefaults(defineProps<Props>(), {
        estModifiable: false,
        modeSuppression: false,
    })

    const activite = defineModel<ActiviteAction>({
        required: true,
    })
    const emit = defineEmits<{
        suppressionDemandée: [ActiviteAction]
        suppressionAnnulée: [ActiviteAction]
    }>()

    const estRéalisé = ref(isDefined(activite.value.dateDeDebut))
    const aSupprimer = ref<boolean>(false)

    watch(estRéalisé, (newValue) => {
        switch (newValue) {
            case true:
                activite.value.dateDeDebut = new Date()
                break
            case false:
                activite.value.dateDeDebut = undefined
                break
        }
    })

    watch(aSupprimer, (newValue) => {
        switch (newValue) {
            case true:
                aSupprimer.value = true
                emit('suppressionDemandée', activite.value)
                break
            case false:
                aSupprimer.value = false
                emit('suppressionAnnulée', activite.value)
                break
        }
    })

    watch(
        () => props.modeSuppression,
        () => {
            if (props.modeSuppression === false) {
                aSupprimer.value = false
            }
        }
    )

    const peutSupprimerLActivité =
        isDefined(myself.value) && activite.value.canBeDeletedBy(myself.value)

    function cardIsDisabled() {
        if (props.estModifiable) {
            return false
        }

        if (!props.modeSuppression) {
            return true
        }

        return peutSupprimerLActivité ? false : true
    }

    function réaliserActionPrincipal() {
        if (props.modeSuppression) {
            aSupprimer.value = !aSupprimer.value
        } else {
            estRéalisé.value = !estRéalisé.value
        }
    }
</script>

<template>
    <v-card
        variant="text"
        :disabled="cardIsDisabled()"
        @click.prevent="réaliserActionPrincipal()"
    >
        <template #prepend>
            <div>
                <v-icon v-if="!estModifiable" class="ma-2">{{
                    estRéalisé ? 'mdi-check' : 'mdi-checkbox-blank-off-outline'
                }}</v-icon>
                <v-checkbox-btn
                    v-else
                    v-model="estRéalisé"
                    color="success"
                ></v-checkbox-btn>
            </div>
        </template>
        <template #title>
            <p
                :class="{ 'text-decoration-line-through': aSupprimer }"
                data-cy="titre-activite"
            >
                <strong v-if="isDefined(activite.getFormatedDurée())">{{
                    activite.getFormatedDurée()
                }}</strong>
                {{ activite.intervenant?.nomComplet ?? '' }}
                <span
                    v-if="
                        (isDefined(activite.getFormatedDurée()) ||
                            isDefined(activite.intervenant?.nomComplet)) &&
                        activite.getItemTitle().length !== 0
                    "
                    >-</span
                >
                {{ activite.getItemTitle() }}
            </p>
        </template>
        <template #subtitle>
            <span :class="{ 'text-decoration-line-through': aSupprimer }">
                {{ activite.getItemDescription() }}
            </span>
        </template>

        <template v-if="!estModifiable" #text>
            <div
                class="text-end"
                :class="{ 'text-decoration-line-through': aSupprimer }"
            >
                {{ activite.getItemTemporalData() }}
            </div>
        </template>

        <template #append>
            <template v-if="modeSuppression">
                <v-checkbox
                    v-if="peutSupprimerLActivité"
                    v-model="aSupprimer"
                    data-cy="bouton-suppression-activite"
                    color="error"
                />

                <v-icon v-else class="mx-2">mdi-lock-outline</v-icon>
            </template>
            <template v-if="!modeSuppression">
                <v-icon v-if="activite.isObligatoire" size="small" class="mx-2">
                    mdi-asterisk
                </v-icon>
            </template>
        </template>
    </v-card>
</template>
